library XT_ItemTypeDemo;

{This is a sample X-Tension that simply demonstrates the XWF_GetItemType function.}

uses Windows, XT_API;

function XT_Init(nVersion, nFlags: DWord; hMainWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	if nVersion shr 16 >= 1890 then
		Result:=2 // we accept to be called by v18.9 and later, and we claim to be a thread-safe X-Tension
	else
		Result:=-1; // we are picky and do not want to be run by older versions because we use special flags of the XWF_GetItemType function
end;

function XT_About(hTopWnd: HWnd; lpReserved: Pointer): LongInt; stdcall; export;
begin
	MessageBox(hTopWnd, 'This is a sample X-Tension provided by X-Ways for demonstration purposes only.', 'Demo', MB_ICONINFORMATION);
end;

function XT_ProcessItem(nItemID: LongInt; lpReserved: Pointer): LongInt; stdcall; export;
const
	BufLen=256;
var
	Buf: array[0..BufLen-1] of WideChar;
begin
	Result:=0;

	XWF_OutputMessage(XWF_GetItemName(nItemID), $2);
	XWF_OutputMessage('seems to have this type, type description, and category:', $1 or $2);

	XWF_GetItemType(nItemID, Buf, BufLen); // get file type designation
	if Buf[0]<>#0 then
		XWF_OutputMessage(Buf, $1 or $2);

	XWF_GetItemType(nItemID, Buf, BufLen or $20000000); // get file type description
	if Buf[0]<>#0 then
		XWF_OutputMessage(Buf, $1 or $2);

	XWF_GetItemType(nItemID, Buf, BufLen or $40000000); // get category designation
	if Buf[0]<>#0 then
		XWF_OutputMessage(Buf, $1 or $2);
end;

exports
	XT_Init,
	XT_About,
	XT_ProcessItem;

end.
